package be.iminds.ilabt.jfed.restapi.dao;

import be.iminds.ilabt.jfed.restapi.json.Experiment;
import be.iminds.ilabt.jfed.restapi.json.ExperimentBuilder;
import be.iminds.ilabt.jfed.restapi.json.SpeaksForCredential;
import be.iminds.ilabt.jfed.restapi.json.SpeaksForCredentialBuilder;
import be.iminds.ilabt.jfed.util.GeniUrn;
import org.skife.jdbi.v2.StatementContext;
import org.skife.jdbi.v2.tweak.ResultSetMapper;

import java.net.MalformedURLException;
import java.net.URL;
import java.sql.ResultSet;
import java.sql.SQLException;

public class SpeaksForCredentialMapper implements ResultSetMapper<SpeaksForCredential>
{
    public SpeaksForCredential map(int index, ResultSet r, StatementContext ctx) throws SQLException
    {
        SpeaksForCredentialBuilder res = new SpeaksForCredentialBuilder();
        res.setExpire(r.getTimestamp("expire"));
        res.setCredentialXml(r.getString("credential"));
        try {
            String speaker = r.getString("speaker");
            res.setSpeaker(speaker == null ? null : new GeniUrn(speaker));
        } catch (GeniUrn.GeniUrnParseException e) {
            throw new SQLException("Malformed speaking_for URN stored in DB", e);
        }
        try {
            String speakingFor = r.getString("speaking_for");
            res.setSpeakingFor(speakingFor == null ? null : new GeniUrn(speakingFor));
        } catch (GeniUrn.GeniUrnParseException e) {
            throw new SQLException("Malformed speaking_for URN stored in DB", e);
        }
        return res.create();
    }
}
