package be.iminds.ilabt.jfed.restapi.jfedclient;

import be.iminds.ilabt.jfed.lowlevel.AnyCredential;
import be.iminds.ilabt.jfed.lowlevel.SimpleGeniUserWithSpeaksFor;
import be.iminds.ilabt.jfed.lowlevel.userloginmodel.InvalidLoginException;
import be.iminds.ilabt.jfed.restapi.JFedRestApiConfiguration;
import be.iminds.ilabt.jfed.util.GeniUrn;

import javax.inject.Inject;
import java.io.File;
import java.io.IOException;
import java.util.Collections;

/**
 * JFedExperimenterApiFactory
 */
public class JFedExperimenterApiFactoryImpl implements JFedExperimenterApiFactory {
    private final JFedRestApiConfiguration conf;

    @Inject
    public JFedExperimenterApiFactoryImpl(JFedRestApiConfiguration conf) {
        this.conf = conf;
    }

    @Override
    public JFedExperimenterApi create(AnyCredential speaksForCredential, GeniUrn speakingFor)
            throws SimpleGeniUserWithSpeaksFor.InvalidSpeaksForException, InvalidLoginException, IOException {
        return new JFedExperimenterApiImpl(
                new File(conf.getSfaUserLoginPemFilename()),
                null,
                Collections.singletonList(speaksForCredential),
                speakingFor);
    }
}
